# -*- coding: UTF-8 -*-

import ConfigParser
import nes_common.logger as logger
import nes_exec
import os
import sys
from nes_command import Command
from nes_common.inserter import Inserter


class DB_Inserter(Inserter):
    def __init__(self, shop, loadDictStatusSender=None, disableProgressFile=False):
        log = logger.getLogger("Shop", shop['shopId'])
        config = ConfigParser.RawConfigParser()
        if not config.read(os.path.join(os.path.dirname(os.path.abspath(__file__)), '../../config/nes_load.ini')):
            log.error("Configuration file 'nes_load.ini' not found")
            sys.exit(1)
        host = config.get('mysql', 'host')
        port = config.getint('mysql', 'port')
        user = config.get('mysql', 'user')
        password = config.get('mysql', 'password')
        executor = nes_exec.Exec(host=host, port=port, user=user, password=password, database='dictionaries',
                                 shopCode=shop['shopId'], config=config, loadDictStatusSender=loadDictStatusSender)
        if disableProgressFile:
            executor.progressEnable = None

        log.info('Инициализация')
        Inserter.__init__(self, shop['shopId'], executor)

    def getCommand(self, simpleCommands):
        return Command(self.executor, self.shopCode, simpleCommands=simpleCommands, modes=['ANY', 'CASH'])
