# -*- coding: UTF-8 -*-

import ConfigParser
import sys
import nes_common.logger as logger
from nes_common.request_executor import RequestExecutor


class DB_RequestExecutor(RequestExecutor):
    def __init__(self, shop, isCash):
        shopId = shop.get('shopId', '')
        log = logger.getLogger('Shop', shopId)
        config = ConfigParser.RawConfigParser()
        if not config.read(sys.path[0] + "/../../../config/nes_load.ini"):
            log.error("Configuration file 'nes_load.ini' not found.")
            sys.exit(1)
        host = config.get('mysql', 'host')
        port = config.getint('mysql', 'port')
        user = config.get('mysql', 'user')
        password = config.get('mysql', 'password')
        database = 'dictionaries'
        if not isCash:
            suffix = shopId
            clusterId = shop.get('clusterId', '')
            if shopId.endswith('All') and shopId.startswith(clusterId):
                suffix = 'All'
            database = '%sdictionaries%s' % (clusterId, suffix)
        RequestExecutor.__init__(self, host, port, user, password, database, shopId)
