# -*- coding: UTF-8 -*-

import ConfigParser
import os
from artix.common import logger


defaultLoggerConf = {
    'version': 1,
    'loggers': {
        '': {  # root logger
            'level': 'DEBUG',
            'handlers': ['nesHandler'],
            'propagate': False
        },
        'nesUploadService': {
            'level': 'DEBUG',
            'handlers': ['nesHandler'],
            'propagate': False
        },
        'nesUploadShop': {
            'level': 'DEBUG',
            'handlers': ['nesHandler'],
            'propagate': False
        },
        'nesUploadcash': {
            'level': 'DEBUG',
            'handlers': ['nesHandler'],
            'propagate': False
        }
    },
    'handlers': {
        'nesHandler': {
            'level': 'DEBUG',
            'formatter': 'nesUploadServiceFormatter',
            'class': 'logging.handlers.RotatingFileHandler',
            'filename': '/tmp/nes.log',
            'mode': 'a',
            'maxBytes': 5000000,
            'backupCount': 10
        }
    },
    'formatters': {
        'nesUploadServiceFormatter': {
            'format': '%(asctime)s %(thread)d %(levelname)-8s %(message)s %(module)5s(%(lineno)s)'
        }
    }
}


def getLogDirectory():
    config = ConfigParser.RawConfigParser()
    configPath = os.path.join(os.path.dirname(os.path.realpath(__file__)), '../../config/nes_load.ini')
    if not config.read(configPath):
        print(u"Configuration file '%s' not found." % configPath)
    sectionName = 'MAIN'
    paramName = 'logDirectory'
    return config.get(sectionName, paramName) if config.has_section(sectionName) and config.has_option(sectionName, paramName) else '/tmp'


def getLogger(name, fileName=None):
    name = 'nesUpload' + name
    fileName = os.path.join(getLogDirectory(), (('nesUpload' + fileName) if fileName else name) + '.log')
    return logger.SimpleLogger(fileName, name,
            configPath=os.path.join(os.path.dirname(os.path.realpath(__file__)), '../../config/logging.properties'),
            dictConfigObject=defaultLoggerConf).getLogger()
