# -*- coding: UTF-8 -*-

import MySQLdb
import MySQLdb.cursors
import nes_common.logger as logger


class RequestExecutor(object):
    def __init__(self, host, port, user, password, database, shopCode):
        self.log = logger.getLogger('Shop', shopCode)
        self.database = database
        if not password or password == '':
            connection = MySQLdb.connect(host=host, port=port, user=user, db=database, cursorclass=MySQLdb.cursors.DictCursor)
        else:
            connection = MySQLdb.connect(host=host, port=port, user=user, passwd=password, db=database, cursorclass=MySQLdb.cursors.DictCursor)
        connection.set_character_set('utf8')
        self.cursor = connection.cursor()
    
    def execute(self, request):
        result = []
        try:
            self.log.debug(u'Execute request in DB %s: "%s"' % (self.database, request))
            self.cursor.execute(request)
            for row in self.cursor:
                resultRow = {}
                for k, v in row.iteritems():
                    resultRow[k.lower()] = str(v)
                result.append(resultRow)
        except Exception as e:
            self.log.error(u'Can not execute request: "%s". %s' % (request, e))
        return result
