'''
Created on 20.08.2010

@author: gsu
'''

import mysql.simplesql as sql
import datetime

tables = ['card']

def insertCard(card):
    yield sql.Insert(table='card', values={
            "idcard":card.get('idcard', None),
            "idcardgroup":card.get('idcardgroup', None),
            "idclient":card.get('idclient', None),
            "number":card.get('number', None),
            "validitydatebeg":card.get('validitydatebeg', None) if card.get('validitydatebeg', None) else None,
            "validitydateend":card.get('validitydateend', None) if card.get('validitydateend', None) else None,
            "cardSum":card.get('cardsum', None),
            "blocked":card.get('blocked', None),
            "lastknownbonusbalance":card.get('lastknownbonusbalance', None),
            "lastknownbonusbalancedate":card.get('lastknownbonusbalancedate', None) if card.get('lastknownbonusbalancedate', None) else None,
            "multiplicator":card.get('multiplicator', None),
            "multiplicatorbeg":card.get('multiplicatorbeg', None) if card.get('multiplicatorbeg', None) else None,
            "multiplicatorend":card.get('multiplicatorend', None) if card.get('multiplicatorend', None) else None,
            "multiplicatorcurrent":card.get('multiplicatorcurrent', None),
            "discountpercent":card.get("discountpercent", None),
            "pincode":card.get("pincode", None),
            "purchases":card.get("purchases", None),
            "cardstatus":card.get("cardstatus", None),
            "shopcode": card.get("shopcode", None),
            })

def deleteCard(card):
    for i in deleteCardById(card.get('idcard', None)):
        yield i

def deleteCardById(idcard):
    yield sql.Delete(table='card', whereFields=['idcard'], whereValues=[idcard])

def update(card, byField):
    cardFields = list(card)
    cardFields.remove(byField)
    cardValues = []
    for field in cardFields:
        cardValues.append(card.get(field, None))
    return sql.Update(table='card',
                 fields=cardFields,
                 values = cardValues,
                 whereField=byField,
                 whereValue=[card.get(byField, None)])

def updateCard(card):
    if card.get('idcard', None) != None:
        yield update(card, 'idcard')
    elif card.get('number', None) != None:
        yield update(card, 'number')

def clearCard():
    yield sql.DeleteAll(table='card')
