import mysql.simplesql as sql

tables = ['certificate']

def insertCertificate(certificate):
    vatcode = certificate.get('vatcode', None)

    taxGroupCode = certificate.get('taxgroupcode', None)
    if taxGroupCode:
        vatcode = taxGroupCode * 100 + 1

    yield sql.Insert(table='certificate', values={
                                                'code': certificate.get('code', None),
                                                'rangefrom': certificate.get('rangefrom', None),
                                                'rangeto': certificate.get('rangeto', None),
                                                'name': certificate.get('name', None),
                                                'sum': certificate.get('sum', None),
                                                'inputmask': certificate.get('inputmask', None),
                                                'fullyspend': certificate.get('fullyspend', None),
                                                'skiplastsymbol': certificate.get('skiplastsymbol', None),
                                                'tmccode': certificate.get('tmccode', None),
                                                'minsum': certificate.get('minsum', None),
                                                'maxsum': certificate.get('maxsum', None),
                                                'multiplesum': certificate.get('multiplesum', None),
                                                'deptcode': certificate.get('deptcode', None),
                                                'vatcode': vatcode,
                                                'paymentobject': certificate.get('paymentobject', None),
                                                'regexpattern': certificate.get('regexpattern', None),
                                                'discountcampaign': certificate.get('discountcampaign', None)
                                                })

def deleteCertificate(certificate):
    for i in deleteCertificateByCode(certificate.get('code', None)):
        yield i

def deleteCertificateByCode(code):
    yield sql.Delete(table='certificate', whereFields=['code'], whereValues=[code])

def clearCertificate():
    yield sql.DeleteAll(table='certificate')
