'''
Created on 12.04.2012

@author: kov
'''

import mysql.simplesql as sql

tables = ['disccardaccumulate', 'accumulatesprices']

def discs(scheme):
    for disc in scheme.get('discount', []):
        yield disc

def insertDiscCardAccumulate(scheme):
    disccodes = map(lambda discount: discount.get('disccode', 0), scheme.get('discount', []))
    yield sql.DeleteNotNestedItems(table='disccardaccumulate', mainCodeField='discscheme', mainCodeValue=scheme.get('discscheme', None),
                                   nestedCodeField='disccode', nestedCodeIn=disccodes)
    for disc in discs(scheme):
        yield sql.Insert(table='disccardaccumulate', values={
           'discscheme': scheme.get('discscheme', None),
           'discschemename': scheme.get('discschemename', None),
           
           'disccode': disc.get('disccode', None),
           'name': disc.get('name', None),
           'rtext': disc.get('rtext', None),
           'discperc': disc.get('discperc', None),
           'isbegsum': disc.get('isbegsum', None),
           'begsum': disc.get('begsum', None),           
           'isendsum': disc.get('isendsum', None),
           'endsum': disc.get('endsum', None),           
           'isbegrcount': disc.get('isbegrcount', None),
           'begrcount': disc.get('begrcount', None),           
           'isendrcount': disc.get('isendrcount', None),
           'endrcount': disc.get('endrcount', None)
           })

def insertLDiscAccumulate(scheme):
    discschemeCode = scheme.get('discscheme', None)
    if discschemeCode:
        yield sql.Insert(table='accumulatesprices', values={
               'code': discschemeCode,
               'name': scheme.get('discschemename', None),
               })

    for d in insertDiscCardAccumulate(scheme):
        yield d

def deleteLDiscAccumulate(scheme):
    shemeCode = scheme.get('discscheme', None)
    yield sql.Delete(table='disccardaccumulate',
                     whereFields=['discscheme'],
                     whereValues=(shemeCode,))
    yield sql.Delete(table='accumulatesprices',
                     whereFields=['code'],
                     whereValues=(shemeCode,))

def clearLDiscAccumulate():
    yield sql.DeleteAll(table='disccardaccumulate')
    yield sql.DeleteAll(table='accumulatesprices')

def deleteLDiscAccumulateByCode(code):
    yield sql.Delete(table='disccardaccumulate',
                     whereFields=['discscheme'],
                     whereValues=[code])
    yield sql.Delete(table='accumulatesprices',
                     whereFields=['code'],
                     whereValues=(code,))
