import mysql.simplesql as sql

tables = ['macro', 'macroparameters']

def insertMacro(macro):
    yield sql.Insert(table='macro', values={
           'macrocode': macro.get('macrocode', 0),
           'macroname': macro.get('macroname', None),
           })
    yield sql.Delete(table='macroparameters', whereFields=['macrocode'], whereValues=(macro.get('macrocode', ''),))
    if macro.get('macroparameters',None):
        for r in macro.get('macroparameters',):
            yield sql.Insert(table= 'macroparameters', values={
            'macroparameterorder': r.get('macroparameterorder', None),
            'cmactioncode': r.get('cmactioncode', None),
            'macrocode': macro.get('macrocode', None),
            })

def deleteMacro(macro):
    yield sql.Delete(table='macro',
                     whereFields=['macrocode'],
                     whereValues=(macro.get('macrocode', 0),))
                     
    yield sql.Delete(table='macroparameters',
                     whereFields=['macrocode'],
                     whereValues=(macro.get('macrocode', ''),))

def clearMacro():
    yield sql.DeleteAll(table='macro')
    yield sql.DeleteAll(table='macroparameters')

def deleteMacroByCode(code):
    yield sql.Delete(table='macro',
                     whereFields=['macrocode'],
                     whereValues=[code])
                     
    yield sql.Delete(table='macroparameters',
                     whereFields=['macrocode'],
                     whereValues=(code,))