'''
Created on 26.05.2011

@author: kov
'''

import mysql.simplesql as sql

tables = ['mol', 'roleuser']

def insertMCashUser(user):
    yield sql.Insert(table='mol', values={
           'code': user.get('code', ''),
           'login': user.get('login', ''),
           'loginmode': None,
           'name': user.get('name', None),
           'password': user.get('password', None),
           'locked': user.get('locked', 0),
           'usergroup': None,
           'drawer': None,
           'start': None ,
           'keyposition':user.get('keyposition', None),
           'rank':user.get('rank', None),
           'inn': user.get('inn', None),
           })
    yield sql.Delete(table='roleuser', whereFields=['usercode'], whereValues=(user.get('code', ''),))
    if user.get('roleusers',None):
        for r in user.get('roleusers',):
            yield sql.Insert(table= 'roleuser', values={
            'usercode': user.get('code', ''),
            'rolecode': r.get('rolecode', 0),
            'rule': r.get('rule', 1),
            })

def deleteMCashUser(user):
    yield sql.Delete(table='mol',
                     whereFields=['code'],
                     whereValues=(user.get('code', ''),))
    yield sql.Delete(table='mol',
                     whereFields=['login'],
                     whereValues=(user.get('login', ''),))
                     
    yield sql.Delete(table='roleuser',
                     whereFields=['usercode'],
                     whereValues=(user.get('code', ''),))

def clearMCashUser():
    yield sql.DeleteAll(table='mol')
    yield sql.DeleteAll(table='roleuser')

def deleteMCashUserByCode(code):
    yield sql.Delete(table='mol',
                     whereFields=['code'],
                     whereValues=[code])
                     
    yield sql.Delete(table='roleuser',
                     whereFields=['usercode'],
                     whereValues=(code,))
