# -*- coding: utf-8 -*-

'''
Created on 09.12.2016

@author: chvv
'''

import datetime
import mysql.simplesql as sql

tables = ['remain']

def insertRemain(remain):
    yield sql.Insert(table='remain',values={
                    'documentid': remain.get('documentid', None),
                    'barcode': remain.get('barcode', None),
                    'changetype': remain.get('changetype', None),
                    'count': remain.get('count', 0),
                    'effectivedate': remain.get('effectivedate', datetime.datetime.now().strftime("%Y-%m-%d %H:%M:%S"))
                    })

def deleteRemain(documentid, barcode=None, changetype=None):
    yield sql.Delete(table='remain',
                     whereFields=['documentid', 'barcode', 'changetype'],
                     whereValues=[documentid, barcode, changetype])

def deleteRemainByObj(remain):
    for i in deleteRemain(remain.get('documentid', None), remain.get('barcode', None), remain.get('changetype', None)):
        yield i

def clearRemain():
    yield sql.DeleteAll(table='remain')

def deleteRemainsBeforeDate(barcode, effectivedate=None):
    if effectivedate == None:
        barcode_effectivedate = sql.Select(table='remain', fields=['barcode, effectivedate'], whereFields=['changetype', 'barcode'], whereValues=['0', '%s' % barcode], arbitraryCondition='AND effectivedate <= NOW()')
        yield sql.DeleteBeforeDate(table='remain', whereFields=['barcode'], whereValues=barcode_effectivedate, dateField='effectivedate')
    else:
        yield sql.DeleteBeforeDate(table='remain', whereFields=['barcode'], whereValues=[barcode], dateField='effectivedate', dateValue=effectivedate)
