'''
Created on 27.05.2011

@author: kov
'''

import mysql.simplesql as sql

tables = ['role', 'rolerelation', 'rolecommand']

def insertRole(role):
    yield sql.Insert(table='role', values={
            'rolecode': role.get('rolecode', 0),
            'rolename': role.get('rolename', None),
            })

    yield sql.Delete(table='rolerelation', whereFields=['primaryrole'], whereValues=(role.get('rolecode', 0),))
    yield sql.Delete(table='rolerelation', whereFields=['secondaryrole'], whereValues=(role.get('rolecode', 0),))
    yield sql.Delete(table='rolecommand', whereFields=['rolecode'], whereValues=(role.get('rolecode', 0),))

    if role.get('rolerelations',None):
        for r in role.get('rolerelations',):
            yield sql.Insert(table= 'rolerelation', values={
            'primaryrole': role.get('rolecode', 0),
            'secondaryrole': r.get('secondaryrole', 0),
            'rule': r.get('rule', 1),
            })

    if role.get('rolecommands',None):
        for r in role.get('rolecommands',):
            yield sql.Insert(table= 'rolecommand', values={
            'rolecode': role.get('rolecode', 0),
            'commandcode': r.get('commandcode', 0),
            'documenttype': r.get('documenttype', 0),
            'rule': r.get('rule', 1),
            })

def deleteRole(role):
    yield sql.Delete(table='role',
                     whereFields=['rolecode'],
                     whereValues=(role.get('rolecode', 0),))

    yield sql.Delete(table='rolerelation',
                     whereFields=['primaryrole'],
                     whereValues=(role.get('rolecode', 0),))

    yield sql.Delete(table='rolerelation',
                     whereFields=['secondaryrole'],
                     whereValues=(role.get('rolecode', 0),))

    yield sql.Delete(table='rolecommand',
                     whereFields=['rolecode'],
                     whereValues=(role.get('rolecode', 0),))

def clearRole():
    yield sql.DeleteAll(table='role')
    yield sql.DeleteAll(table='rolerelation')
    yield sql.DeleteAll(table='rolecommand')

def deleteRoleByCode(code):
    yield sql.Delete(table='role',
                     whereFields=['rolecode'],
                     whereValues=[code])

    yield sql.Delete(table='rolerelation',
                     whereFields=['primaryrole'],
                     whereValues=(code, ))

    yield sql.Delete(table='rolerelation',
                     whereFields=['secondaryrole'],
                     whereValues=(code, ))

    yield sql.Delete(table='rolecommand',
                    whereFields=['rolecode'],
                    whereValues=(code,))

