import mysql.simplesql as sql
import datetime

tables = ['softcheck', 'softcheckposition']

def insertSoftCheck(softCheck):
    softcheckid = softCheck.get('softcheckid', None)
    yield sql.Insert(table='softcheck', values={
            "softcheckid": softcheckid,
            "creationDate": softCheck.get('creationdate', None),
            "options": softCheck.get('options', None)})

    yield sql.Delete(table='softcheckposition', whereFields=['softcheckid'], whereValues=[softcheckid])
    for position in softCheck.get('positions', []):
        yield sql.Insert(table='softcheckposition', values={
                'softcheckid': softcheckid,
                'barcode': position.get('barcode', None),
                'quantity': position.get('quantity', None),
                'name': position.get('name', None),
                'code': position.get('code', None),
                'articul': position.get('articul', None),
                'measure': position.get('measure', None),
                'cquant': position.get('cquant', None),
                'quantityDefault': position.get('quantitydefault', None),
                'quantityLimit': position.get('quantitylimit', None),
                'group': position.get('group', None),
                'documentDepartament': position.get('documentdepartament', None),
                'deptNumber': position.get('deptnumber', None),
                'deptNumberAll': position.get('deptnumberall', None),
                'price': position.get('price', None),
                'priceIndexAll': position.get('priceindexall', None),
                'priceType': position.get('pricetype', None),
                'priceValCode': position.get('pricevalcode', None),
                'minimumPrice': position.get('minimumprice', None),
                'priceSelectMode': position.get('priceselectmode', None),
                'sum': position.get('sum', None),
                'backMode': position.get('backmode', None),
                'isNotCalculate': position.get('isnotcalculate', None),
                'withoutCollection': position.get('withoutcollection', None),
                'useAspects': position.get('useaspects', None),
                'packingMode': position.get('packingmode', None),
                'taraWeight': position.get('taraweight', None),
                'vatcode1': position.get('vatcode1', None),
                'vatrate1': position.get('vatrate1', None),
                'vatsum1': position.get('vatsum1', None),
                'vatcode2': position.get('vatcode2', None),
                'vatrate2': position.get('vatrate2', None),
                'vatsum2': position.get('vatsum2', None),
                'vatcode3': position.get('vatcode3', None),
                'vatrate3': position.get('vatrate3', None),
                'vatsum3': position.get('vatsum3', None),
                'vatcode4': position.get('vatcode4', None),
                'vatrate4': position.get('vatrate4', None),
                'vatsum4': position.get('vatsum4', None),
                'vatcode5': position.get('vatcode5', None),
                'vatrate5': position.get('vatrate5', None),
                'vatsum5': position.get('vatsum5', None),
                'tags': position.get('tags', None)})

def deleteSoftCheck(softCheck):
    for i in deleteSoftCheckById(softCheck.get('softcheckid', None)):
        yield i

def deleteSoftCheckById(softcheckid):
    yield sql.Delete(table='softcheck', whereFields=['softcheckid'], whereValues=[softcheckid])
    yield sql.Delete(table='softcheckposition', whereFields=['softcheckid'], whereValues=[softcheckid])

def clearSoftCheck():
    yield sql.DeleteAll('softcheck')
    yield sql.DeleteAll('softcheckposition')
